---
Title: Some git tricks
Date: 2019-04-22 17:00
Author: Fabrice
Category: cheat sheets
Slug: git-tricks
Header_Cover: images/cover_water.jpg
---

Some [git](https://git-scm.com/) tricks I use from time to time and that I forgot everytime…

**Disclaimer:** I'm not the perfect git user, and my way of using it is especially crude.
Recently, most of my git commits are due to [`pass`](/password-store.html), therefore most of those commands are here to fix my mistakes.

Reset `master` to `origin/master`:
```sh
git co origin/master -B master
```

Find back lost commits, especially useful when you are doing dirty things and want to `cherry-pick` an orphan commit (for instance):
```sh
git log --graph --reflog
```
Some explanations: `--graph` show the commit tree, which is useful to notice the orphan leafs, and `--reflog` shows the world all the dirtiness you've done.

If you noticed that your folder grows, you can manually cast the garbage collector on it. It should do it automatically, but not often enough according to my standards.
```sh
git gc --aggressive
```

Another useful trick is `git commit -v`, it allows reviewing your changes before committing.

![Example](/examples/git-cv.svg)


